> For the complete documentation index, see [llms.txt](https://headless.intelligems.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://headless.intelligems.io/version-1.0.0-beta/reference/hooks/cart-and-checkout-hooks.md).

# Cart & Checkout Hooks

## `useIgCart()`

Use this hook if your site manages user carts through the Storefront Cart API.

Requires the `cartId`.  The hook will add a cart attribute to each cart session.

Returns a `wrapCustomAttributes` Function.  This function will add Intelligems-required line item properties to any existing line item properties.

<pre class="language-typescript" data-overflow="wrap"><code class="lang-typescript">interface WrapStorefrontItemCustomAttributesParams{
    productId: string;
    variantId: string;
    customAttributes?: {
        key: string;
        value: string;
    }[] | null;
};

interface WrapStorefrontItemCustomAttributesResponse {
    key: string;
    value: string;
}[];
<strong>
</strong><strong>const useIgCart: (cartOrCheckoutToken: string) => {
</strong>    wrapCustomAttributes: (options: WrapStorefrontItemCustomAttributesParams) => WrapStorefrontItemCustomAttributesResponse;
};
</code></pre>

## `useIgCheckout()`

Use this hook if your site manages user carts through the Storefront Checkout API.

Requires the `checkoutId`.  The hook will add a checkout attribute to each checkout session.

Returns a `wrapCustomAttributes` Function.  This function will add Intelligems-required line item properties to any existing line item properties.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://headless.intelligems.io/version-1.0.0-beta/reference/hooks/cart-and-checkout-hooks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
